const video = document.querySelector('.plyx-player')

function VideoLength() {
    // Duration and Length of Video
    const timeElapsed = document.getElementById('time-elapsed');
    const duration = document.getElementById('duration');

    function formatTime(timeInSeconds) {
        const result = new Date(timeInSeconds * 1000).toISOString().substr(11, 8);

        return {
            minutes: result.substr(3, 2),
            seconds: result.substr(6, 2),
        };
    };


    function initializeVideo() {
        const videoDuration = Math.round(video.duration);
        const time = formatTime(videoDuration);
        duration.innerText = `${time.minutes}:${time.seconds}`;
        duration.setAttribute('datetime', `${time.minutes}m ${time.seconds}s`);
    }
    video.addEventListener('loadedmetadata', initializeVideo);
    function updateTimeElapsed() {
        const time = formatTime(Math.round(video.currentTime));
        timeElapsed.innerText = `${time.minutes}:${time.seconds}`;
        timeElapsed.setAttribute('datetime', `${time.minutes}m ${time.seconds}s`);
    }
    video.addEventListener('timeupdate', updateTimeElapsed);

    // Progress Bar
    const progressBar = document.getElementById('progress-bar');
    const seek = document.getElementById('seek');
    function initializeVideo() {
        const videoDuration = Math.round(video.duration);
        seek.setAttribute('max', videoDuration);
        progressBar.setAttribute('max', videoDuration);
        const time = formatTime(videoDuration);
        duration.innerText = `${time.minutes}:${time.seconds}`;
        duration.setAttribute('datetime', `${time.minutes}m ${time.seconds}s`)
    }

    function updateProgress() {
        seek.value = Math.floor(video.currentTime);
        progressBar.value = Math.floor(video.currentTime);
    }
    
    video.addEventListener('timeupdate', updateProgress);

    const seekTooltip = document.getElementById('seek-tooltip');

    function updateSeekTooltip(event) {
    const skipTo = Math.round((event.offsetX / event.target.clientWidth) * parseInt(event.target.getAttribute('max'), 10));
    seek.setAttribute('data-seek', skipTo)
    const t = formatTime(skipTo);
    seekTooltip.textContent = `${t.minutes}:${t.seconds}`;
    const rect = video.getBoundingClientRect();
    seekTooltip.style.left = `${event.pageX - rect.left}px`;
    }

    seek.addEventListener('mousemove', updateSeekTooltip);

    function skipAhead(event) {
        const skipTo = event.target.dataset.seek ? event.target.dataset.seek : event.target.value;
        video.currentTime = skipTo;
        progressBar.value = skipTo;
        seek.value = skipTo;
    }
    seek.addEventListener('input', skipAhead);

    initializeVideo()
}

export {VideoLength}